/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
		
CLASSE_VOITURE = {};

/**
 * Simulation de la classe javascript.
 * 
 */
(function(){ // dbut de scope local
	CLASSE_VOITURE.utils = CLASSE_VOITURE.utils || {}; // cration d'un sous namespace pour stocker des classes utilitaires si celui-ci n'est pas dj cr

   /**
	* @brief Constructeur de la classe.
	* @param -
	*/
	CLASSE_VOITURE.utils.voiture = function(couleur, marque, type, nbrePlaces, nbrePorte, options) {		
		this.sCouleur = couleur;
		this.sMarque = marque;
		this.sType = type;

		this.iNombrePlaces = nbrePlaces;
		this.iNombrePortes = nbrePorte;
 
		this.aOptions = options;

		this.initNom("Premiere voiture");	
	};

	/**
	 * Dfinition des variables et des mthodes publiques propres  chaque instance.
	 * 
	 * Note : il n'est pas conseill de dclarer des mthodes prives en javacsript, cela peut rduire les performances.
	 */
	CLASSE_VOITURE.utils.voiture.prototype = {
			
		// les proprits / variables de la classe	
		sCouleur:'',
		sMarque:'',
		sType:'',
		
		nom:'',
		
		iNombrePlaces:0,
		iNombrePortes:0,
 
		aOptions:[],

		// les mthodes de la classe
		
		/**
		 * Dfinit le nom par dfaut de la voiture.
		 * 
		 */
		initNom:function(valeur) {
			this.nom = valeur;
		},
		
		changeCouleur:function(valeur) {
			this.sCouleur = valeur;
		},
		
		/**
		 * Ajoute une option.
		 * 
		 */
		ajoutOption:function(valeur) {
			this.aOptions.push(valeur);
		},
		
		
		/**
		 * Getter / setter pour modifier / lire le type de la voiture.
		 * 
		 */
	    get type(){
	        return this.sType;
	    },
	    set type(valeur){
	        this.sType = valeur;
	    },
	    
	    /**
		 * Renvoie toutes les informations de la voiture.
		 * 
		 */ 
		getDetails:function() {
			var sInformations = "Nom: "+this.nom+" - Couleur: "+this.sCouleur+" - Marque: "+this.sMarque+" - Type: "+this.sType;
			sInformations += " - Nombre de places: "+ this.iNombrePlaces+" - Nombre de portes: "+ this.iNombrePortes;		
			sInformations +=" - Les options: "+this.aOptions.toString();// implode permet de convertir un tableau en chaine de caractres
			return sInformations;
		}
		
	};


	}) (); // fin du scope local		

// utilisation de la classe
console.log("---> exemple javascript voiture");// avec extension firebug

var oClio = new CLASSE_VOITURE.utils.voiture( "verte", "Renault", "Citadine", 4, 3, ["fermeture centralisee", "vitres electriques"] ); 
console.log("Voiture : "+ oClio.getDetails() );

oClio.nom = "Clio verte";// change son nom
oClio.type = "decapotable";// setter
oClio.changeCouleur("bleu");// change sa couleur
oClio.ajoutOption("toit ouvrant");// ajoute une option
console.log("Voiture : "+oClio.getDetails() );// affiche les caractristiques de la voiture

//cration d'une autre instance, une autre voiture
var oScenic = new CLASSE_VOITURE.utils.voiture("blanche", "Renault", "Familiale", 5, 5, ["fermeture centralisee", "vitres electriques", "peinture metalisee"] );
oScenic.nom = "Scenic blanc";
console.log("Voiture : "+oScenic.getDetails() );// affiche les caractristiques de la voiture