/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package {
	
	import com.demonsters.debugger.MonsterDebugger;
	
	/**
	 * Classe voiture
	 * @author Matthieu
	 */
	public class Voiture
	{
		// les propriétés de la classe privées, non accessibles par les autres classes
		private var sCouleur:String;
		private var sMarque:String;
		private var sType:String;
		
		private var iNombrePlaces:int;
		private var iNombrePortes:int;
		private var aOptions:Array;
		
		
		// une propriété public accessible par les autres classes
		public var nom:String;
		
		
		
		/**
		 * Le constructeur.
		 * 
		 */
		public function Voiture(couleur:String, marque:String, type:String, nbrePlaces:int, nbrePorte:int, options:Array)
		{
			sCouleur = couleur;
			sMarque = marque;
			sType = type;
			
			iNombrePlaces = nbrePlaces;
			iNombrePortes = nbrePorte;
			
			aOptions = options;
			
			this.initNom("Première voiture");		
		}
		
		
		// méthode privée non accessible par les autres classes.
		
		/**
		 * Définit le nom par défaut de la voiture.
		 * 
		 */
		private function initNom(valeur:String):void
		{
			nom = valeur;
		}
		
		
		// les méthodes de la classe accessibles par les autres classes
		public function changeCouleur( sValeur:String):void
		{
			sCouleur = sValeur;
			MonsterDebugger.trace(this, "Voiture changeCouleur : "+ sCouleur );// affiche la nouvelle couleur de la voiture
		}
		
		
		/**
		 * Ajoute une option.
		 * 
		 */
		public function ajoutOption(valeur:String):void
		{
			aOptions.push(valeur);
		}

				
		/**
		 * Renvoie toutes les informations de la voiture.
		 * 
		 */
		public function getDetails():String
		{
			var sInformations:String = "Nom: "+nom+" - Couleur: "+sCouleur+" - Marque: "+sMarque+" - Type:"+sType+
			" - Nombre de places: "+String(iNombrePlaces)+" - Nombre de portes: "+String(iNombrePortes)+
			" - Les options:"+aOptions.toString();
			
			 return sInformations;
		}
		
		
		/**
		 * Getter / setter pour modifier / lire le type de la voiture.
		 * 
		 */
		public function get type() : String
		{
			// possibilité de rajouter des calculs...
			return sType;
		}
		
		public function set type(value : String) : void
		{
			// possibilité de rajouter des calculs...
			sType = value;
		}
		

	}
	
	
}
